divert(-1)
#
# MakeXS.m4
#
#*************************************************************************
# This program or document is free software; you can redistribute it	 *
# and/or modify it under the terms of the GNU General Public License as	 *
# published by the Free Software Foundation ; either version 2 of the	 *
# License, or (at your option) any later version.						 *
#																		 *
# This document is distributed in the hope that it will be useful, but	 *
# without any warranty; without even the implied warranty of			 *
# merchantability or fitness for a particular purpose. See the GNU		 *
# General Public License for more details.								 *
#																		 *
# No Warranty															 *
# Because the program or document is licensed free of charge, there is no*
# warranty for the program, to the extent permitted by applicable law.	 *
# Except when otherwise stated in writing the copyright holders and/or	 *
# other parties provide the program "as is" without warranty of any kind,*
# either expressed or implied, including, but not limited to, the implied*
# warranties of merchantability and fitness for a particular purpose. The*
# entire risk as to the quality and performance of the program is with	 *
# you. Should the program prove defective, you assume the cost of all	 *
# necessary servicing, repair or correction.							 *
#																		 *
# In no event unless required by applicable law or agreed to in writing	 *
# will any copyright holder, or any other party who may modify and/or	 *
# redistribute the program or document as permitted above, be liable to	 *
# you for damages, including any general, special, incidental or		 *
# consequential damages arising out of the use or inability to use the	 *
# program or document (including but not limited to loss of data or data *
# being rendered inaccurate or losses sustained by you or third parties	 *
# or a failure of the program to operate with any other programs), even	 *
# if such holder or other party has been advised of the possibility of	 *
# such damages.															 *
#*************************************************************************
#
# This is used to generate a MakeXS file using the m4 processor.
# This defines variables and targets.  The output is
# documented by the macros.
#
# The macros's are self documenting.
#
# ---- Place the following comment into the MakeXS file. ----
divert`'dnl
#
# MakeXS
#		*****************************************************************
#		* generated from MakeXS.m4 - DO NOT EDIT THIS FILE - it will	*
#		* be overwritten.  Edit MakeXSConf.m4 for application specific	*
#		* changes and MakeXS.m4 for MakeXS structure changes.		*
#		*****************************************************************
#
#	This is intended to be used in every Makefile in the system
#	being built. It provides the basic support for all standard
#	targets and standard variables.
#
#	There are a number of advantages to keeping a unified make structure.
#	1. Simplifies systems with complex subdirectories, avoiding repeating
#		common build commands making it easy to make sweeping simple
#		changes to the build process.
#	2. Simplifies Makefile creation in each subdirectory.  Simply
#		defining a couple of variables and then including this file.
#		e.g.
#		IN_CPPFILES=$(wildcard *$(MXS_CPP_EXTENSION))
#		IN_TARGETS_ALL=$(MXS_CXXOBJS)
#		include Makefile.xsi
#
#	The basic method is that all the local Makefile files need is
#	to define a set variables that determine desired operation
#	and then include MakeXS followed by any rules specific to
#	to that file.
#
#	Variable prefix conventions -
#		IN_		defined in the host Makefile
#		INL_	defined in the user's environment
#		INS_	defined for subsystem
#		ING_	defined globally - usually defined in MakeXSConf.m4
#		MXS_	Makefile variables in MakeXS
#		M4X_	M4 macros defined in MakeXS.m4 (private ones)
#		MIN_	M4 macros defined in MakeXS.m4 (public ones)
#		IN4_	M4 macros defined in MakeXSConf.m4
#		xxx_	(Pick your favorite <xxx_> Makefile macros defined
#					in MakeXSConf.m4
#
# The following appears as the MakeXS file
#	Standard targets are:
#
#		The following targets are defined by MakeXS.  To perform
#		an operation on a target you will need to define IN_TARGETS_<TARGET>
#		before you include this file.  e.g. if you would like to have XFile
#		build on the `all' target - do this :
#			IN_TARGETS_ALL=XFile
#
#		Similarly if you want XFile removed on when you run 'make clean' do
#		this e.g.:
#			IN_FILES_CLEAN=XFile
#
#		Or if you have your own clean target "myclean", you can have the
#		default clean target depend on it - e.g.:
#			IN_TARGETS_CLEAN=myclean
#
#		Defining IN?_SUBMAKEFILES with a list of Makfiles that also
#		need to be executed will cause a list of targets to be generated
#		that can be used.  For example :
#			IN_SUBMAKEFILES=foo/Makefile bar/Makefile
#		Will cause targets "foo/all foo/setup ... bar/all etc" to also be
#		defined - these will also have default actions that will cause
#		the sub-directories to be built.
#			ING_SUBMAKEFILES by default is defined like:
#			ING_SUBMAKEFILES=$(wildcard */Makefile)
#		IN?_SUBMAKEDIRS operates in much the same was as ING_SUBMAKEFILES
#		except that it is a list of directories.
#
#		The target "mxs_version" will echo the MakeXS version number.
divert(-1)

# M4forech(x, (item_1, item_2, ..., item_n), stmt)
define(`M4forech', `pushdef(`$1', `')_M4forech(`$1', `$2', `$3')popdef(`$1')')
define(`_Xarg1', `$1')
define(`_M4forech', 
        `ifelse(`$2', `()', ,
                `define(`$1', _Xarg1$2)$3`'_M4forech(`$1', (shift$2), `$3')')')
define(`upcase', `translit(`$*', `a-z/', `A-Z_')')

# forloop macro
#
define(`forloop',
	`pushdef(`$1', `$2')_forloop(`$1', `$2', `$3', `$4')popdef(`$1')')
define(`_forloop',
	`$4`'ifelse($1, `$3', ,
	`define(`$1', incr($1))_forloop(`$1', `$2', `$3', `$4')')')


#
# Include a bunch of application specific macros.
#
include(MakeXSConf.m4)

#
# M4X_IN_VARS_INPUT(variable suffix)
# PURPOSE
#	Create a set of variable assignments for IN?_<suffix>
#
define(`M4X_IN_VARS_INPUT_D',)
define(`M4X_IN_VARS_INPUT',`dnl
define(`M4X_IN_VARS_INPUT_D',defn(`M4X_IN_VARS_INPUT_D')`# MXS_$1 definition
#
# Assign default value of IN4_$1
#
ifneq ($(ING_SUPPRESS_DEFAULT_$1),1)
ING_$1=$(ING_DEFAULT_$1)
endif

MXS_$1=$(INL_$1) $(ING_$1) $(INS_$1) $(IN_$1)

')
')

#
# M4X_IN_VARS_TRANSFORM(variable suffix)
# PURPOSE
#	Transform a variable
#
define(`M4X_IN_VARS_TRANSFORM',`dnl
define(`M4X_IN_VARS_INPUT_D',defn(`M4X_IN_VARS_INPUT_D')`dnl
# MXS_$4 is a transform of MXS_$1 changing suffixes of $2 to $3
#

MXS_$4=$(MXS_$1:%$2=$5%$3)

')
')

#
# M4X_IN_VARS_FOREACH_TRANSFORM(in var,out var,ident,expression)
# PURPOSE
#	Transform a variable using a foreach
#
define(`M4X_IN_VARS_FOREACH_TRANSFORM',`dnl
define(`M4X_IN_VARS_INPUT_D',defn(`M4X_IN_VARS_INPUT_D')`dnl
# MXS_$2 is a transform of MXS_$1
#

MXS_$2=$(foreach $3,$($1),$4)

')
')

define(`M4X_IN_VARS_INPUT_OPTION',`dnl
define(`M4X_IN_VARS_INPUT_D',defn(`M4X_IN_VARS_INPUT_D')`# MXS_$1 definition
#
# Pick the option for MXS_$1 - priority in L, <none>, S, G order
#
ifneq ($(INL_$1),)
MXS_$1=$(INL_$1)
MXS_ISSET_$1=1
endif

ifeq ($(INL_UNSET_$1),1)
MXS_$1=
MXS_ISSET_$1=1
endif

ifneq ($(MXS_ISSET_$1),1)
ifneq ($(IN_$1),)
MXS_$1=$(IN_$1)
MXS_ISSET_$1=1
endif
endif

ifneq ($(MXS_ISSET_$1),1)
ifeq ($(IN_UNSET_$1),1)
MXS_$1=
MXS_ISSET_$1=1
endif
endif

ifneq ($(MXS_ISSET_$1),1)
ifneq ($(INS_$1),)
MXS_$1=$(INS_$1)
MXS_ISSET_$1=1
endif
endif

ifneq ($(MXS_ISSET_$1),1)
ifeq ($(INS_UNSET_$1),1)
MXS_$1=
MXS_ISSET_$1=1
endif
endif

ifelse($2,,`dnl
ifneq ($(MXS_ISSET_$1),1)
MXS_$1=$(ING_DEFAULT_$1)
MXS_ISSET_$1=1
endif

',`dnl
ifneq ($(MXS_ISSET_$1),1)
MXS_$1=$2
MXS_ISSET_$1=1
endif

')
')
')

#
# M4X_IN_VARS_OPTION_XFRM(suffix,xformed variable,prefix,suffix)
# PURPOSE
#	Collect all information about variables
#
define(`M4X_IN_VARS_OPTION_XFRM',`dnl
define(`M4X_IN_VARS_INPUT_D',defn(`M4X_IN_VARS_INPUT_D')`# MXS_$1 definition

ifneq ($($2),)
MXS_$1=$3$($2)$4
else
MXS_$1=
endif

')
')

#
# M4X_IN_VARS_DEFS(variable suffix,description)
# PURPOSE
#	Collect all information about variables
#
define(`M4X_IN_VARS_DEFS_D',)
define(`M4X_IN_VARS_DEFS',`dnl
define(`M4X_IN_VARS_DEFS_D',defn(`M4X_IN_VARS_DEFS_D')`# IN?_$1 'dnl
substr(`                    ',len($1),20)`$2
')
')

#
# M4X_IN_VARS_TRANSFORM_DEFS(variable suffix,description)
# PURPOSE
#	Collect all information about variables
#
define(`M4X_IN_VARS_TRANSFORM_DEFS',`dnl
define(`M4X_IN_VARS_DEFS_D',defn(`M4X_IN_VARS_DEFS_D')`#      'dnl
`                    MXS_$4 is MXS_$1 with extensions $2 changed to $3
')
')

#
# M4X_IN_VARS_FOREACH_TRANSFORM_DEFS(variable suffix,description)
# PURPOSE
#	Collect all information about variables
#
define(`M4X_IN_VARS_FOREACH_TRANSFORM_DEFS',`dnl
define(`M4X_IN_VARS_DEFS_D',defn(`M4X_IN_VARS_DEFS_D')`#      'dnl
`                    MXS_$1 : $2
')
')

#
# M4X_IN_TARGS_DESC_D(target_name,description)
# PURPOSE
#	Collect all information about targets
#
define(`M4X_IN_TARGS_DESC_D',)
define(`M4X_IN_TARGS_DESC',`dnl
define(`M4X_IN_TARGS_DESC_D',defn(`M4X_IN_TARGS_DESC_D')`# $1 'dnl
substr(`                ',len($1),16)`$2
')
')

#
# M4X_IN_TARGS_DEFS_D(target_name,description,rule,base macro name)
# PURPOSE
#	Collect all information about targets
#
define(`M4X_IN_TARGS_DEFS_D',)
define(`M4X_IN_TARGS_DEFS',`dnl
define(`M4X_IN_TARGS_DEFS_D',defn(`M4X_IN_TARGS_DEFS_D')`
.PHONY : $1 $1_default $1_thisdir
$1 : $1_thisdir
$1_thisdir : $1_default
$1_default :
$(MXS_BASE_TARGET_$4) : $(MXS_$2)
ifelse($3,,,`	$3')
')
')

define(`M4X_IN_TARGS_SUBS_D',)
define(`M4X_IN_TARGS_SUBS',`dnl
define(`M4X_IN_TARGS_SUBS_D',defn(`M4X_IN_TARGS_SUBS_D')`
MXS_SUBDIR_TARG_$2=$(MXS_MAKEDIRS:%=%/$1)
.PHONY: $(MXS_SUBDIR_TARG_$2)
$1 : $(MXS_SUBDIR_TARG_$2)

$(MXS_SUBDIR_TARG_$2) :
	MXI_ROOT="$(MXI_ROOT)"; export MXI_ROOT; \
	if [ -f $(@D)/Makefile.$(MXI_ARCH) ]; then \
		$(MAKE) $(MXS_PARALLEL_$2) -C $(@D) -f Makefile.$(MXI_ARCH) $1; \
	else \
		$(MAKE) $(MXS_PARALLEL_$2) -C $(@D) $1; \
	fi

r_$1 release_$1 :
	INL_RELEASE_BUILD=1; export INL_RELEASE_BUILD; $(MAKE) $1

')
')

#
# MIN_BASE_TARGET(target_name,caps_name,action,description)
# PURPOSE
#	This macro defines a "standard" or base target for all Makefiles.
#	It will use variable names IN?_TARGETS_<caps_name> as the input
#	for targets.
#
define(`MIN_BASE_TARGET',`dnl
	M4X_IN_TARGS_DESC(`$1',`$4')
	M4X_IN_VARS_INPUT(`TARGETS_$2')
	M4X_IN_VARS_DEFS(`TARGETS_$2',`dependantcies for "$1" base target')
	M4X_IN_TARGS_DEFS(`$1',`TARGETS_$2',`$3',`$2')
	M4X_IN_TARGS_SUBS(`$1',`$2')
	M4X_IN_VARS_INPUT_OPTION(`PARALLEL_JOBS_$2')
	M4X_IN_VARS_DEFS(`PARALLEL_JOBS_$2',`Number of jobs to execute in parallel')
	M4X_IN_VARS_FOREACH_TRANSFORM(`MXS_PARALLEL_JOBS_$2',`PARALLEL_$2',`zX',`-j $(zX)')
	M4X_IN_VARS_INPUT_OPTION(`BASE_TARGET_$2',`$1_default')
	M4X_IN_VARS_DEFS(`BASE_TARGET_$2',`Base target for all MSB_TARGETS_$2 targets - defaults to "$1"')
')

#
# MIN_BASE_VARIABLE(name suffix,description)
# PURPOSE
#	This macro defines a "standard" variable for all Makefiles.
#
define(`MIN_BASE_VARIABLE',`dnl
	M4X_IN_VARS_INPUT(`$1')
	M4X_IN_VARS_DEFS(`$1',`$2')
')

#
# MIN_BASE_FILE_LIST(name suffix,file suffix, new suffix,new name,new prefix,description)
# PURPOSE
#	This macro defines a "standard" variable for all Makefiles.
#
define(`MIN_BASE_FILE_LIST',`dnl
	M4X_IN_VARS_INPUT(`$1')
	M4X_IN_VARS_TRANSFORM(`$1',`$2',`$3',`$4',`$5')
	M4X_IN_VARS_DEFS(`$1',`$6')
	M4X_IN_VARS_TRANSFORM_DEFS(`$1',`$2',`$3',`$4')	
')

#
# MIN_BASE_FILE_LIST_XFORM(name suffix,file suffix, new suffix,new name,new prefix,description)
# PURPOSE
#	Provide a transform for a variable
#
define(`MIN_BASE_FILE_LIST_XFORM',`dnl
	M4X_IN_VARS_TRANSFORM(`$1',`$2',`$3',`$4',`$5')
	M4X_IN_VARS_TRANSFORM_DEFS(`$1',`$2',`$3',`$4')	
')



#
# MIN_BASE_OPTION_VARIABLE(name suffix,description)
# PURPOSE
#	This macro defines a "standard" OPTION variable for all Makefiles.
#	These environmen variables have only 1 value
#
define(`MIN_BASE_OPTION_VARIABLE',`dnl
	M4X_IN_VARS_INPUT_OPTION(`$1')
	M4X_IN_VARS_DEFS(`$1',`Option - $2')
')

#
# MIN_BASE_MODIFIED_VARIABLE(name suffix,xformed variable,prefix,suffix,description)
# PURPOSE
#	This macro defines a variable with a prefix or suffix
#
define(`MIN_BASE_MODIFIED_VARIABLE',`dnl
	M4X_IN_VARS_OPTION_XFRM(`$1',`$2',`$3',`$4')
	M4X_IN_VARS_FOREACH_TRANSFORM_DEFS(`$1',`$5 dervied $3+$2+$4 only when $2 is set')
')

#
# MIN_BASE_TRANSFORMED(in var,out var,id,expression,description)
# PURPOSE
#	Define a variable that transforms a list.
#
define(`MIN_BASE_TRANSFORMED',`dnl
	M4X_IN_VARS_FOREACH_TRANSFORM(`$1',`$2',`$3',`$4')
	M4X_IN_VARS_FOREACH_TRANSFORM_DEFS(`$2',`$5')
')

# define  base targets
MIN_BASE_TARGET(all,ALL,,`perform regular build - create all build files')
MIN_BASE_TARGET(setup,SETUP,,`on a top level make it will build a directory structure')
MIN_BASE_TARGET(test,TEST,,`run unit test')
MIN_BASE_TARGET(clean,CLEAN,`$(RMRF) $(MXS_FILES_CLEAN)',`remove intermediate build files')
MIN_BASE_TARGET(mostlyclean,MOSTLYCLEAN,`$(RMRF) $(MXS_FILES_MOSTLYCLEAN)',`like clean')
MIN_BASE_TARGET(distclean,DISTCLEAN,`$(RMRF) $(MXS_FILES_DISTCLEAN)',`revert to checked out state')
MIN_BASE_TARGET(docs,DOCS,,`build whatever docs need building')
MIN_BASE_TARGET(install,INSTALL,,`targets that install previously built files')
MIN_BASE_TARGET(uninstall,UNINSTALL,,`targets that remove from installation')
MIN_BASE_TARGET(cvsadd_all,CVSADD_ALL,`( $(CVS) add *; true)',`add all files to CVS - do this after a distclean')
MIN_BASE_TARGET(rebuild_vcproj,REBUILD_VCPROJ,,`Recreate visual studio project files')

# define base variables
MIN_BASE_OPTION_VARIABLE(BUILDDIR,`Directory where all built files are placed')
MIN_BASE_MODIFIED_VARIABLE(BUILDPREFIX,MXS_BUILDDIR,,`/',`Build file prefix')
MIN_BASE_OPTION_VARIABLE(CXX_EXECUTABLE,`The final executable being produced using C++')
MIN_BASE_OPTION_VARIABLE(C_EXECUTABLE,`The final executable being produced using C++')
MIN_BASE_OPTION_VARIABLE(STATIC_RELOCATABLE,`This defines the name of the .o to be produced')
MIN_BASE_TRANSFORMED(MXS_STATIC_RELOCATABLE,STATIC_RELOCATABLE_NAME,`relocatable',`$(MXS_BUILDPREFIX)$(relocatable).o',`Name of actual relocatable object file')
MIN_BASE_OPTION_VARIABLE(STATIC_LIBRARY,`This defines the name of the .a to be produced')
MIN_BASE_TRANSFORMED(MXS_STATIC_LIBRARY,STATIC_LIBRARY_NAME,`archive',`$(MXS_BUILDPREFIX)$(archive).a',`Name of actual archive')
MIN_BASE_OPTION_VARIABLE(CXX_DSO,`This defines the name of a c++ Dynamic Shared Object')
MIN_BASE_TRANSFORMED(MXS_CXX_DSO,CXX_DSO_NAME,`dynamic_lib',`$(dynamic_lib).so',`Name of actual DSO')
MIN_BASE_OPTION_VARIABLE(C_DSO,`This defines the name of a c++ Dynamic Shared Object')
MIN_BASE_TRANSFORMED(MXS_C_DSO,C_DSO_NAME,`dynamic_lib',`$(dynamic_lib).so',`Name of actual DSO')
MIN_BASE_OPTION_VARIABLE(CPP_EXTENSION,`C++ file extension')
MIN_BASE_OPTION_VARIABLE(WHEREIS_ALL,`Determines the operation of the whereis command')
MIN_BASE_VARIABLE(LIBS,`libraries for linking')
MIN_BASE_VARIABLE(INCL_EXCLUDE_PATTERNS,`Include directories not to be added to MXS_GEN_INCLUDEDIRS')
MIN_BASE_TRANSFORMED(MXS_LIBS,LIBS_OPTS,`Popt',`-l$(Popt)',`-l options for linking CLIBS')
MIN_BASE_FILE_LIST(SUBMAKEFILES,/Makefile,`',SUBMAKEFDIRS,`',`List of Makefiles in directories to be built')
MIN_BASE_VARIABLE(SUBMAKEDIRS,`List of directories to be built')
MIN_BASE_TRANSFORMED(MXS_ARCH_FILT_SUBMAKEDIRS,WIN32_PROJECTS,`Dir',`win32/projects/$(Dir)/$(Dir).vcproj',`List of Visual C++ project files')
MIN_BASE_FILE_LIST(CXXFILES,$(MXS_CPP_EXTENSION),.o,CXXOBJS,`$(MXS_BUILDPREFIX)',`Files with $(MXS_CPP_EXTENSION) extension - creates MXS_CXXOBJS')
MIN_BASE_FILE_LIST(CFILES,.c,.o,COBJS,`$(MXS_BUILDPREFIX)',`Files with .c - creates MXS_COBJS')
MIN_BASE_OPTION_VARIABLE(PREBUILD_SUFFIX,`Suffix for pre-built bundles')
MIN_BASE_OPTION_VARIABLE(USE_PREBUILT_BUNDLES,`This will force the use of pre-built bundles')
MIN_BASE_OPTION_VARIABLE(EX_PACKAGE_NAME,`The name of the package e.g. libxml2')
MIN_BASE_OPTION_VARIABLE(EX_VERS_STR,`The version string e.g. 2.6.8')
MIN_BASE_OPTION_VARIABLE(EX_URL_SRC,`The source URL that is prefixed to the DIST_NAME e.g. ftp://xmlsoft.org/')
MIN_BASE_OPTION_VARIABLE(EX_RELEASE_TYPE,`Usually an appendix to the version string e.g. rc1')
MIN_BASE_OPTION_VARIABLE(EX_MODULE_VERS_SEPARATOR,`A separator in the module (directory) name between package and version')
MIN_BASE_OPTION_VARIABLE(EX_DIST_VERS_SEPARATOR,`A separator in the distribution name between package and version')
MIN_BASE_OPTION_VARIABLE(EX_EXTRACT_METHOD,`The distribution file type (TGZ, TBZ2, ZIP)')
MIN_BASE_OPTION_VARIABLE(EX_MODULE_NAME,`The module name (directory) default is comprised of name+separator+version')
MIN_BASE_OPTION_VARIABLE(EX_DISTRO_NAME,`The distributed file name (excluding suffix) e.g. libxml2-2.6.8')
MIN_BASE_OPTION_VARIABLE(EX_TGZ_NAME,`The full name of the distributed file for TGZ files - including the suffix e.g. libxml2-2.6.8.tar.tgz')
MIN_BASE_OPTION_VARIABLE(EX_TGZ_EXTRACT_CMD,`The command to extract for a TGZ file default "gunzip < ../$^ | tar xf -"')
MIN_BASE_OPTION_VARIABLE(EX_TBZ2_NAME,`The full name of the distributed file for TBZ2 files - including the suffix e.g. libxml2-2.6.8.tar.bz2')
MIN_BASE_OPTION_VARIABLE(EX_TBZ2_EXTRACT_CMD,`The command to extract for a TBZ2 file default "bunzip2 < ../$^ | tar xf -"')
MIN_BASE_OPTION_VARIABLE(EX_ZIP_NAME,`The full name of the distributed file for TBZ2 files - including the suffix e.g. libxml2-2.6.8.zip')
MIN_BASE_OPTION_VARIABLE(EX_ZIP_EXTRACT_CMD,`The command to extract for a ZIP file default "unzip -x ../$^"')
MIN_BASE_OPTION_VARIABLE(EX_DIST_NAME,`The actual distribution name for the EXTRACT_METHOD  e.g. EXTRACT_METHOD=TGZ then DIST_NAME=libxml2-2.6.8.tar.tgz')
MIN_BASE_OPTION_VARIABLE(EX_EXTRACTS,`Directory where to extract distribution - usually MXS_BUILDDIR')
MIN_BASE_OPTION_VARIABLE(EX_EXTRACTS_BUILD_DIR,`Directory where to build inside extracted directory - usually EX_MODULE_NAME')
MIN_BASE_OPTION_VARIABLE(EX_PREBUILT_FILE,`The filename of prebuilt files - e.g. prebuilt-libxml2-2.6.8-release-win32.tbz')
MIN_BASE_OPTION_VARIABLE(EX_BUILD_START,`Built start commands - usually a CD into the appropriate directory - default cd work.gx86; PACKAGE_ROOT=pwd; export PACKAGE_ROOT; cd extracts')
MIN_BASE_OPTION_VARIABLE(MOZ_TOOLS,`MOZ_TOOLS will set the environment variable MOZ_TOOLS for use by mozilla builds - MUST USE "\" e.g. c:\stuff NOT c:/stuff')
MIN_BASE_OPTION_VARIABLE(USE_CYGWIN_GCC,`If this is set, the default will be changed target list will be changed')



define(`m4_suffixes',`(`sql',`htm',`html',`pl',`pm',`httpd_conf')')

M4forech(Ix,m4_suffixes,`
MIN_BASE_FILE_LIST(upcase(Ix)M4FILES,.Ix.m4,.Ix,upcase(Ix)FILES,`$(MXS_BUILDPREFIX)',`Files with .Ix.m4 - creates MXS_`'upcase(Ix)FILES')
MIN_BASE_FILE_LIST(upcase(Ix)M4FILES_LOCAL,.Ix.m4,.Ix,upcase(Ix)FILES_LOCAL,`',`Files with .Ix.m4 - creates MXS_`'upcase(Ix)FILES')
')

MIN_BASE_FILE_LIST(YYACC_FILES,.yy,.tab$(MXS_CPP_EXTENSION),YYACCCXX_FILES,`$(MXS_BUILDPREFIX)',`Files with .yy - creates MXS_YYACCCXX_FILES')
MIN_BASE_FILE_LIST_XFORM(YYACC_FILES,.yy,.tab.hh,YYACCHXX_FILES,`$(MXS_BUILDPREFIX)',`')
MIN_BASE_FILE_LIST_XFORM(YYACC_FILES,.yy,.tab.o,YYACCOBJ_FILES,`$(MXS_BUILDPREFIX)',`')
MIN_BASE_FILE_LIST(TEST_CXXFILES,$(MXS_CPP_EXTENSION),.o,TEST_CXXOBJS,`$(MXS_BUILDPREFIX)',`Test files with $(MXS_CPP_EXTENSION) extension - creates TEST_CXXOBJS')
MIN_BASE_FILE_LIST(TEST_CFILES,.c,.o,TEST_COBJS,`$(MXS_BUILDPREFIX)',`Test files with .c - creates MXS_COBJS')
MIN_BASE_OPTION_VARIABLE(INSTALL_HOME,`Where all files to be installed go')
MIN_BASE_VARIABLE(INSTALL_HOME_DIRS,`The list of directories in install home')
MIN_BASE_TRANSFORMED(MXS_BUILD_HOME_DIRS,BUILD_NAMES,`name',`$(MXS_BUILD_HOME)/$(MXS_BUILDPREFIX)$(name)',`List of actual build directories')
MIN_BASE_VARIABLE(IDIRS,`A list of directories to create -I flags')
MIN_BASE_TRANSFORMED(MXS_IDIRS,ICFLAGS,`Popt',`-I $(Popt)',`-I options for pre processor')
MIN_BASE_VARIABLE(LDIRS,`A list of directories to create -L flags')
MIN_BASE_TRANSFORMED(MXS_LDIRS,LCFLAGS,`Popt',`-L$(Popt)',`-L options for linker')
MIN_BASE_VARIABLE(LINKOBJS,`A list of objects to link by default')
MIN_BASE_VARIABLE(LDFLAGS,`Options to the linker')
MIN_BASE_VARIABLE(CXXLIBS,`A list of library names to be included as -l flags')
MIN_BASE_TRANSFORMED(MXS_CXXLIBS,CXXLIBS_OPTS,`Popt',`-l$(Popt)',`-l options for linking CXXLIBS')
MIN_BASE_VARIABLE(OCFLAGS,`Optimizer or debugging flags')
MIN_BASE_VARIABLE(CFLAGS,`Other flags for the compiler')
MIN_BASE_VARIABLE(CXXFLAGS,`Other flags for the c++ compiler')
MIN_BASE_VARIABLE(ASFLAGS,`flags for the assembler')
MIN_BASE_VARIABLE(CPPFLAGS,`Other flags for the c/c++ pre processor')
MIN_BASE_VARIABLE(YFLAGS,`Yacc (or bison) flags')
MIN_BASE_VARIABLE(LFLAGS,`Lex (or flex) flags')


M4forech(Ix,m4_suffixes,`
MIN_BASE_VARIABLE(upcase(Ix)M4FLAGS,`M4 flags used on %.Ix : %.Ix.m4 rule')
')

MIN_BASE_VARIABLE(FILES_CLEAN,`Files to remove when running target clean')
MIN_BASE_VARIABLE(FILES_MOSTLYCLEAN,`Files (not including CLEAN list) to remove for mostlyclean')
MIN_BASE_VARIABLE(FILES_DISTCLEAN,`Files (not including CLEAN and MOSTLYCLEAN) to remove for distclean')
MIN_BASE_OPTION_VARIABLE(MSDEV_ARG,`MSDEV option - e.g. /REBUILD')
MIN_BASE_OPTION_VARIABLE(MSDEV32_RESULT_EXTENSION,`MSDEV result extension - e.g. .lib')
MIN_BASE_OPTION_VARIABLE(MSDEV32_BUILD_TYPE,`MSDEV build type - e.g. "Win32 Debug"')
MIN_BASE_OPTION_VARIABLE(DEVENV_BUILD_TYPE,`Build type for developer studio (devenv) e.g. "Debug" or "Release"')
MIN_BASE_OPTION_VARIABLE(MSDEV32_BUILD_OPTION,`Defaults to "module - Win32 Debug" - can be over-ridden')
MIN_BASE_OPTION_VARIABLE(MSDEV32_BUILD_COMMAND,`The full win32 dsp build command - can be over-ridden')
MIN_BASE_FILE_LIST_XFORM(MSDEV32_DSPFILE,.dsp,.$(MXS_MSDEV32_RESULT_EXTENSION),MSDEV32_RESULT,`$(MXS_BUILDPREFIX)',`MSDEV dsp files - creates MSDEV32_RESULT')
MIN_BASE_OPTION_VARIABLE(MSDEV_ARG,`MSDEV option - e.g. /REBUILD')
MIN_BASE_OPTION_VARIABLE(MSVS_BUILD_TYPE,`set to one of LIBRARY, CONSOLE, WINDOWS')
MIN_BASE_OPTION_VARIABLE(MSVS_PROJECT_NAME,`This is the name of the %.vcproj name - e.g MSVS_PROJECT_NAME=sys for sys.vcproj ')
MIN_BASE_OPTION_VARIABLE(MSVS_TEST_PROJECT,`when test to TRUE forces the creation of a test .vcproj file.')
MIN_BASE_OPTION_VARIABLE(OFFICIAL_BUILD,`Official build flag')
MIN_BASE_OPTION_VARIABLE(RELEASE_BUILD,`Release build')
MIN_BASE_OPTION_VARIABLE(OFFICIAL_BUILD_VERS,`Version of the official build')
MIN_BASE_OPTION_VARIABLE(SKIP_INCLUDE_DIR_BUILD,`Set this to skip the build of the include directories')
MIN_BASE_OPTION_VARIABLE(MIDL_INCLUDE_PATH,`The default include path for midl include files')

define(`doxygen_configs',`(`PROJECT_NAME',`PROJECT_NUMBER',`OUTPUT_DIRECTORY',`BIN_ABSPATH',`EXT_DOC_PATHS',`INPUT',`INCLUDE_PATH',`HAVE_DOT')')

M4forech(Ix,doxygen_configs,`
MIN_BASE_OPTION_VARIABLE(DOX_`'upcase(Ix),`Doxygen configuration 'Ix)
')

MIN_BASE_OPTION_VARIABLE(DOX_BASE_CONFIG_SCRIPT,`This script takes creates a doxygen config file from environment vars')
MIN_BASE_OPTION_VARIABLE(DOX_SUBDIR,`The subdirectory that is selected for doxygen scanning.')

MIN_BASE_OPTION_VARIABLE(FILE_BROWSER,`The command line tool to launch a browser.')

IN4_APPLICATION_VARIABLES()
#
#
divert`'dnl
#
M4X_IN_TARGS_DESC_D()dnl
#
#	Environment variables:
#
#		The list of environment variables below change the behaviour of
#		this Makefile. The '?' can be one of these:
#			<empty> - Define these in the input Makefile for the directory
#			G - These are global defines - usually defined in this file.
#			L - Defined in the user's environment
#			S - Defined in the subsystem
#		For option like variables there is a priority order for
#		these defines (L, <empty>, S, G).
#

M4X_IN_VARS_DEFS_D()dnl
#

#
# all is the default target !
#

all:

#
#
#
MXS_VERSION=1.0

mxs_version:
	@ echo $(MXS_VERSION)

#
# The default vcproj rebuild target depends on IN*_MSVS_PROJECT_NAME being set
#
	
ING_DEFAULT_TARGETS_REBUILD_VCPROJ=$(if $(MXS_MSVS_PROJECT_NAME),force_rebuild_vcproj/$(MXS_MSVS_PROJECT_NAME),)

#
# MOZ_TOOLS
#
ING_DEFAULT_MOZ_TOOLS=C:\moz_tools

#
# Doxygen config file creation script.
#
ING_DEFAULT_DOX_BASE_CONFIG_SCRIPT=$(MXI_ROOT)/make/doxyscript

#
# Doxygen default dox directory location
#
ING_DEFAULT_DOX_SUBDIR=.

#
# Doxygen 
#
ING_DEFAULT_DOX_HAVE_DOT=$(if $(shell which dot),YES,NO)

#
# The default output directory for doxygen files
#
ING_DEFAULT_DOX_OUTPUT_DIRECTORY=$(shell pwd)/dox

#
# absolute path to doxyserach
#
ING_DEFAULT_DOX_BIN_ABSPATH=$(dir $(if $(shell which doxysearch),$(shell which doxysearch),/usr/local/bin/doxysearch))

#
# Default input directory starts from current directory
#

ING_DEFAULT_DOX_INPUT=$(foreach Popt,$(sort $(shell find $(MBS_DOX_SUBDIR) -follow -type d $(FC)!$(FC) -path \*CVS\* $(MXS_DOX_EXCLUDE_FIND_OPTION))),"$(Popt)")

#
# Default input directory starts from current directory
#

ING_DEFAULT_DOX_INCLUDE_PATH=$(foreach Popt,$(MXS_IDIRS),"$(Popt)")

#
# By default, all subdirs are scanned - this is overridden in the top directory's
# Makefile to scan only the src directory
#

ING_DEFAULT_DOX_SUBDIR=.


#
# Defaults to package build rules.
#
ING_DEFAULT_EX_MODULE_VERS_SEPARATOR=-
ING_DEFAULT_EX_DIST_VERS_SEPARATOR=-
ING_DEFAULT_EXTRACT_METHOD=TGZ
ING_DEFAULT_EX_MODULE_NAME=$(MXS_EX_PACKAGE_NAME)$(MXS_EX_MODULE_VERS_SEPARATOR)$(MXS_EX_VERS_STR)
ING_DEFAULT_EX_DISTRO_NAME=$(MXS_EX_PACKAGE_NAME)$(MXS_EX_DIST_VERS_SEPARATOR)$(MXS_EX_VERS_STR)$(MXS_EX_RELEASE_TYPE)
ING_DEFAULT_EX_TGZ_NAME=$(MXS_EX_DISTRO_NAME).tar.gz
ING_DEFAULT_EX_TGZ_EXTRACT_CMD=tar xzf ../$^
#ING_DEFAULT_EX_TGZ_EXTRACT_CMD=gunzip < ../$^ | tar xf -
ING_DEFAULT_EX_TBZ2_NAME=$(MXS_EX_DISTRO_NAME).tar.bz2
#ING_DEFAULT_EX_TBZ2_EXTRACT_CMD=bunzip2 < ../$^ | tar xf -
ING_DEFAULT_EX_TBZ2_EXTRACT_CMD=tar xjf ../$^
ING_DEFAULT_EX_ZIP_NAME=$(MXS_EX_DISTRO_NAME).zip
ING_DEFAULT_EX_ZIP_EXTRACT_CMD=unzip -x ../$^
ING_DEFAULT_EX_DIST_NAME=$(MXS_EX_$(MXS_EX_EXTRACT_METHOD)_NAME)
ING_DEFAULT_EX_EXTRACTS=$(MXS_BUILDDIR)
ING_DEFAULT_EX_EXTRACTS_BUILD_DIR=$(MXS_EX_MODULE_NAME)
ING_DEFAULT_EX_PREBUILT_FILE=prebuilt-$(MXS_EX_MODULE_NAME)-$(MXS_PREBUILD_SUFFIX).tbz
ING_DEFAULT_EX_BUILD_START=cd $(MXS_EX_EXTRACTS); PACKAGE_ROOT=$(BC)pwd$(BC); export PACKAGE_ROOT; cd $(MXS_EX_EXTRACTS_BUILD_DIR)


MXS_EX_EXISTING_PREBUILT_FILE=$(wildcard $(MXS_EX_PREBUILT_FILE))

#
# Dependantcy for pre-built files exists only when the pre built file does not exist
MXS_EX_PREBUILT_DEPENDANTCY=$(if $(MXS_EX_EXISTING_PREBUILT_FILE),,$(MXS_BUILDPREFIX)build_$(MXS_EX_MODULE_NAME) $(MXS_OBJDIR_DEP))

#
# The target to use - this depends on wether pre-built bundles are required.
MXS_EX_ALL_TARGET=$(MXS_BUILDPREFIX)$(if $(MXS_USE_PREBUILT_BUNDLES),prebuild_extract_,fix_includes_)$(MXS_EX_MODULE_NAME)

MXS_EX_EXTRACT_PREFIX=$(MXS_BUILDPREFIX)L_$(MXS_EX_MODULE_NAME)_EXTRACT
MXS_EX_EXTRACT_MARKER=$(MXS_EX_EXTRACT_PREFIX)_$(MXS_EX_EXTRACT_METHOD)



#
#
# MXS_ALL_CXXFILES is a list of all C++ files in the current directory
#
MXS_ALL_CXXFILES=$(wildcard *$(MXS_CPP_EXTENSION))

#
#
# MXS_ALL_CFILES is a list of all C files in the current directory
#
MXS_ALL_CFILES=$(wildcard *.c)

#
# Some WIN32 helper macros
#
#

MXS_MSDEV32_DSPFILE=$(wildcard *.dsp)
MXS_MSDEV32_MODULE_NAME=$(basename $(MXS_MSDEV32_DSPFILE))
ING_DEFAULT_MSDEV32_BUILD_OPTION="$(MXS_MSDEV32_MODULE_NAME) - $(MXS_MSDEV32_BUILD_TYPE)"
ING_DEFAULT_MSDEV32_RESULT_EXTENSION=lib
ING_DEFAULT_MSDEV32_BUILD_TYPE=$(if $(MXS_RELEASE_BUILD),Win32 Release,Win32 Debug)
ING_DEFAULT_DEVENV_BUILD_TYPE=$(if $(MXS_RELEASE_BUILD),Release,Debug)

ING_DEFAULT_MSDEV32_BUILD_COMMAND=\
	$(RMF) $(MXS_MSDEV32_RESULT) ; \
	if test -f $(MXS_MSDEV32_RESULT); then echo "Could not remove resultant file - aborting"; exit 1; fi ; \
	$(MSDEV) $(MXS_MSDEV32_DSPFILE) /MAKE $(MXS_MSDEV32_BUILD_OPTION) $(MXS_MSDEV_ARG); \
	if test \! -f $(MXS_MSDEV32_RESULT); then exit 1; fi

#
# Standard definitions for many useful commands.
# 
IN4_APPLICATION_DEFINES()

ifeq ($(MXI_ARCH),win32)
ING_DEFAULT_FILE_BROWSER=explorer
else
ifeq ($(MXI_ARCH),gx86)
ING_DEFAULT_FILE_BROWSER=konqueror
else
ING_DEFAULT_FILE_BROWSER=mozilla
endif
endif

MXS_ARCH_FILT_SUBMAKEDIRS=$(filter-out $(BUILDM_SUPPORTED_ARCHS),$(MXS_SUBMAKEDIRS))

#
# If there is a Makefile.defs in the current directory then include the
# file here. Makefile.defs is an application specific Makefile that may
# or may not be present.
#
MXS_MAKEFILE_APP=$(wildcard Makefile.defs) $(wildcard Makefile.$(MXI_ARCH).defs)
ifneq ($(MXS_MAKEFILE_APP),)

# first make sure that all is declared ...

`include $(MXS_MAKEFILE_APP)'
endif



M4X_IN_VARS_INPUT_D

#
# Some special defines

# MXS_MAKEDIRS - all subdirectories that need to be built.
MXS_MAKEDIRS=$(MXS_SUBMAKEFDIRS) $(MXS_SUBMAKEDIRS)

#
# Defined some standard macros using the MXS macros
#
CFLAGS=$(MXS_CFLAGS) $(MXS_OCFLAGS)
CXXFLAGS=$(MXS_CXXFLAGS) $(MXS_OCFLAGS)
LDFLAGS=$(MXS_LCFLAGS) $(MXS_LIBS_OPTS) $(MXS_LDFLAGS) $(MXS_CXXLIBS_OPTS)
CPPFLAGS=$(MXS_CPPFLAGS) $(MXS_ICFLAGS)
ASFLAGS=$(MXS_ASFLAGS) $(MXS_OCFLAGS)
YFLAGS=$(MXS_LFLAGS)
LFLAGS=$(MXS_LFLAGS)

IN4_APPLICATION_FLAGS()

release :
	INL_RELEASE_BUILD=1; export INL_RELEASE_BUILD; $(MAKE)

M4X_IN_TARGS_DEFS_D()

IN4_APPLICATION_RULES()

.SUFFIXES: .yy

#
# Keep all build intermediate files
#
.PRECIOUS: $(MXS_BUILDPREFIX)%$(MXS_CPP_EXTENSION) $(MXS_YYACCCXX_FILES)

#
#
# MXS_OBJDIR_DEP is the dependantcy for $(MXS_BUILDPREFIX)
#
ifeq ($(wildcard $(MXS_BUILDDIR)),)
MXS_OBJDIR_DEP=$(MXS_BUILDDIR)
else
MXS_OBJDIR_DEP=
endif

#
# Include files also from the build directory - for generated
# header files

ifneq ($(MXS_BUILD_INCLUDES),1)
ifeq ($(wildcard $(MXI_ROOT)/make/$(MXS_BUILDPREFIX)Includedirs),)
__MXS_BUILD_INCL:=$(shell (MXS_BUILD_INCLUDES=1; export MXS_BUILD_INCLUDES; cd $(MXI_ROOT)/make; make make_Includedirs) )
endif

`include' $(MXI_ROOT)/make/$(MXS_BUILDPREFIX)Includedirs
endif

# Build Includedirs in a MXI_ARCH dependant place.

MXS_GEN_INCLUDEDIRS_X=$(sort $(dir $(shell find $(MXI_ROOT) -follow -name \*.h -type f $(MXS_INCL_EXCLUDE_FIND_OPTION))))
#Z:=$(shell echo find $(MXI_ROOT) -follow -name \*.h -type f $(MXS_INCL_EXCLUDE_FIND_OPTION) 1>&2)

MXS_GEN_STDINCLUDEDIRS_X=$(dir $(addsuffix /a,$(shell touch _my__jnk.cpp; $(CXX) -Wp,-v -c _my__jnk.cpp 2>&1 | grep " /" ; rm -f _my__jnk.* ) ) )


ifeq ($(MXS_SKIP_INCLUDE_DIR_BUILD),1)
ifeq ($(MXS_BUILDPREFIX)Includedirs,$(wildcard $(MXS_BUILDPREFIX)Includedirs))
MXS_DO_SKIP_REBUILD_INCLUDE_DIRS=1
endif
endif

ifneq ($(MXS_DO_SKIP_REBUILD_INCLUDE_DIRS),1)
.PHONY: make_Includedirs

make_Includedirs :
	rm -f $(MXI_ROOT)/make/$(MXS_BUILDPREFIX)Includedirs
	-( cd $(MXI_ROOT)/make; mkdir -p $(MXS_BUILDPREFIX) )
	echo "MXS_GEN_INCLUDEDIRS=$(MXS_GEN_INCLUDEDIRS_X)" > $(MXI_ROOT)/make/$(MXS_BUILDPREFIX)Includedirs
	echo "MXS_GEN_STDINCLUDEDIRS=$(MXS_GEN_STDINCLUDEDIRS_X)" >> $(MXI_ROOT)/make/$(MXS_BUILDPREFIX)Includedirs

else

make_Includedirs :
	echo "Skipping Includedirs generation"
	mkdir -p $(MXI_ROOT)/make/$(MXS_BUILDPREFIX)
	touch $(MXI_ROOT)/make/$(MXS_BUILDPREFIX)Includedirs

endif

includes_rebuild :
	( cd $(MXI_ROOT)/make; $(MAKE) force_MakeXS_rebuild )



MXS_GEN_LIBDIRS_X=$(sort $(dir $(shell find $(MXI_ROOT) -follow -name \*.lib -type f $(MXS_INCL_EXCLUDE_FIND_OPTION))))

make_Libdirs :
	rm -f $(MXI_ROOT)/make/$(MXS_BUILDPREFIX)Libdirs
	-( cd $(MXI_ROOT)/make; mkdir -p $(MXS_BUILDPREFIX) )
	echo "MXS_GEN_LIBDIRS=$(MXS_GEN_LIBDIRS_X)" > $(MXI_ROOT)/make/$(MXS_BUILDPREFIX)Libdirs

MXS_LIBDIRS_INCL=$(wildcard $(MXI_ROOT)/make/$(MXS_BUILDPREFIX)Libdirs)
ifneq ($(strip $(MXS_LIBDIRS_INCL)),)
`include $(MXS_LIBDIRS_INCL)'
endif	



MXS_GEN_LIBFILES_X=$(sort $(notdir $(shell find $(MXI_ROOT) -follow -name \*.lib -type f $(MXS_INCL_EXCLUDE_FIND_OPTION))))

make_Libfiles :
	rm -f $(MXI_ROOT)/make/$(MXS_BUILDPREFIX)Libfiles
	-( cd $(MXI_ROOT)/make; mkdir -p $(MXS_BUILDPREFIX) )
	echo "MXS_GEN_LIBFILES=$(MXS_GEN_LIBFILES_X)" > $(MXI_ROOT)/make/$(MXS_BUILDPREFIX)Libfiles

MXS_LIBFILES_INCL=$(wildcard $(MXI_ROOT)/make/$(MXS_BUILDPREFIX)Libfiles)
ifneq ($(strip $(MXS_LIBFILES_INCL)),)
`include $(MXS_LIBFILES_INCL)'
endif

.PHONY: make_all_cache_files_Libfiles
make_all_cache_files_Libfiles :
	INL_RELEASE_BUILD=; export INL_RELEASE_BUILD; make make_Libfiles
	INL_RELEASE_BUILD=1; export INL_RELEASE_BUILD; make make_Libfiles

.PHONY: make_all_cache_files_Libdirs
make_all_cache_files_Libdirs :
	INL_RELEASE_BUILD=; export INL_RELEASE_BUILD; make make_Libdirs
	INL_RELEASE_BUILD=1; export INL_RELEASE_BUILD; make make_Libdirs

.PHONY: make_all_cache_files_Includedirs
make_all_cache_files_Includedirs :
	INL_RELEASE_BUILD=; export INL_RELEASE_BUILD; make make_Includedirs
	INL_RELEASE_BUILD=1; export INL_RELEASE_BUILD; make make_Includedirs

.PHONY: make_all_cache_files
make_all_cache_files : make_all_cache_files_Includedirs make_all_cache_files_Libdirs make_all_cache_files_Libfiles

	
.PHONY: run_test
run_test : $(IN_CXX_EXECUTABLE)
	$(IN_CXX_EXECUTABLE)

.PHONY: run_test/%
run_test/% : $(IN_CXX_EXECUTABLE)
	$(IN_CXX_EXECUTABLE) $*

.PHONY: run_test_list
run_test_list : $(IN_CXX_EXECUTABLE)
	$(IN_CXX_EXECUTABLE) --list

#
# doxygen rules.
#
#

.PHONY: dox
dox : 
	cd $(MXI_ROOT); $(MAKE) dox_here

dox_gui :
	cd $(MXI_ROOT); $(MAKE) dox_gui_here

dox_gui_here : gui_dir/dox/html

.PHONY: dox_config
dox_config :
	cd $(MXI_ROOT); $(MAKE) dox_here_config

.PHONY: dox_here_config
dox_here_config :
	mkdir -p dox
	( \
M4forech(Ix,doxygen_configs,`dnl
		DOX_`'upcase(Ix)=$(FC)$(MXS_DOX_`'upcase(Ix))$(FC); export DOX_`'upcase(Ix); \
')dnl
		DOX_STRIP_FROM_PATH=$(FC)$(MXI_ROOT)$(FC); export DOX_STRIP_FROM_PATH; \
		$(MXS_DOX_BASE_CONFIG_SCRIPT) > $(MXS_DOX_OUTPUT_DIRECTORY)/doxconf.dat; \
	)
	
	

.PHONY: dox_here
dox_here : dox_here_config
	doxygen $(MXS_DOX_OUTPUT_DIRECTORY)/doxconf.dat

#------------------- package build rules ---------------------


.PHONY: external_all
external_all : $(MXS_EX_ALL_TARGET)

#
# This will install from a pre-built bundle.
#
$(MXS_BUILDPREFIX)prebuild_extract_$(MXS_EX_MODULE_NAME) : $(MXS_EX_PREBUILT_FILE) $(MXS_OBJDIR_DEP)
	( \
		cd $(MXS_EX_EXTRACTS); \
		rm -rf install; \
		mkdir install; \
		cd install; \
		bunzip2 < ../../$(MXS_EX_PREBUILT_FILE) | tar -xf - .  ; \
	)
	touch $@
	$(MAKE) make_Includedirs
	

.PHONY: prebuild
prebuild : $(MXS_EX_PREBUILT_FILE)

#
# This will create a pre-built bundle
#
$(MXS_EX_PREBUILT_FILE) : $(MXS_EX_PREBUILT_DEPENDANTCY)
	( \
		cd $(MXS_EX_EXTRACTS)/install; \
		tar -hcf - . | bzip2 > ../../$(MXS_EX_PREBUILT_FILE) ; \
	)


#
# This will do the basic build
#
$(MXS_BUILDPREFIX)build_$(MXS_EX_MODULE_NAME) : $(MXS_EX_EXTRACT_MARKER)
	( \
		$(MXS_EX_BUILD_START); \
		$(PACKAGEBUILD_CMD) \
	)
	( \
		$(MXS_EX_BUILD_START); \
		$(PACKAGEBUILD_INSTALL) \
	)
	touch $@

#	
# This will force the rebuild of the include path
#
$(MXS_BUILDPREFIX)fix_includes_$(MXS_EX_MODULE_NAME) : $(MXS_BUILDPREFIX)build_$(MXS_EX_MODULE_NAME)
	$(MAKE) make_Includedirs
	touch $@


#	
# Extract and configure using gzip
#
$(MXS_EX_EXTRACT_PREFIX)_TGZ : $(MXS_EX_DIST_NAME)
	rm -rf $(MXS_BUILDDIR)
	mkdir -p $(MXS_BUILDDIR)
	( cd $(MXS_BUILDDIR); $(MXS_EX_TGZ_EXTRACT_CMD)  )
	( \
		$(MXS_EX_BUILD_START); \
		$(PACKAGECONFIGURE) ; \
	)
	touch $(@)

#
# Extract and configure using TBZ2
#
$(MXS_EX_EXTRACT_PREFIX)_TBZ2 : $(MXS_EX_DIST_NAME)
	rm -rf $(MXS_BUILDDIR)
	mkdir -p $(MXS_BUILDDIR)
	( cd $(MXS_BUILDDIR); $(MXS_EX_TBZ2_EXTRACT_CMD) )
	( \
		$(MXS_EX_BUILD_START); \
		$(PACKAGECONFIGURE) ; \
	)
	touch $(@)

#
# Extract and configure using ZIP
#
$(MXS_EX_EXTRACT_PREFIX)_ZIP : $(MXS_EX_DIST_NAME)
	rm -rf $(MXS_BUILDDIR)
	mkdir -p $(MXS_BUILDDIR)
	( cd $(MXS_BUILDDIR); $(MXS_EX_ZIP_EXTRACT_CMD) )
	( \
		$(MXS_EX_BUILD_START); \
		$(PACKAGECONFIGURE) ; \
	)
	touch $(@)

#
# User can provide other extract methods by including
# $(MXS_EX_EXTRACT_PREFIX)_USER_METHOD rule
#

#
# Go and fetch a copy of the distro.
#
$(MXS_EX_DIST_NAME) :
	wget --passive $(MXS_EX_URL_SRC)$@


#
# Dont want the extract marker deleted
#
.PRECIOUS : $(MXS_EX_EXTRACT_MARKER)

#------------------- end of package build rules --------------


#
# Suffix for depends files
#
MXS_DEPSUFFIX=.dep

#
# Basic MXS rules
#

#
# Build bison generated files as c++ files - extension .yy
# these generate .tab.hh and .tab$(MXS_CPP_EXTENSION) files.
#

$(MXS_BUILDPREFIX)%.tab$(MXS_CPP_EXTENSION) $(MXS_BUILDPREFIX)%.tab.hh : %.yy $(MXS_OBJDIR_DEP)
	$(RMRF) $*.yy.tab.h $(MXS_BUILDPREFIX)$*.tab.hh $*.yy.tab.c $(MXS_BUILDPREFIX)$*.tab$(MXS_CPP_EXTENSION)
	$(BISON) -d $<
	$(MV) $*.yy.tab.h $(MXS_BUILDPREFIX)$*.tab.hh
	$(MV) $*.yy.tab.c $(MXS_BUILDPREFIX)$*.tab$(MXS_CPP_EXTENSION)

#
# Build c++ files (sitting in the build directory)
#
$(MXS_BUILDPREFIX)%.o : $(MXS_BUILDPREFIX)%$(MXS_CPP_EXTENSION) $(MXS_OBJDIR_DEP)
	( \
		$(RMF) $(@) $(@)$(MXS_DEPSUFFIX); \
		DEPENDENCIES_OUTPUT="$(@)$(MXS_DEPSUFFIX) $(@)";\
		export DEPENDENCIES_OUTPUT; \
		$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c $< -o $@ \
	)

#
# Build regular c++ into the build directory
#
$(MXS_BUILDPREFIX)%.o : %$(MXS_CPP_EXTENSION) $(MXS_OBJDIR_DEP)
	( \
		$(RMF) $(@) $(@)$(MXS_DEPSUFFIX); \
		DEPENDENCIES_OUTPUT="$(@)$(MXS_DEPSUFFIX) $(@)"; \
		export DEPENDENCIES_OUTPUT; \
		$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c $< -o $@ \
	)

#
# Build c files (sitting in the build directory)
#
$(MXS_BUILDPREFIX)%.o : $(MXS_BUILDPREFIX)%.c $(MXS_OBJDIR_DEP)
	( \
		$(RMF) $(@) $(@)$(MXS_DEPSUFFIX); \
		DEPENDENCIES_OUTPUT="$(@)$(MXS_DEPSUFFIX) $(@)"; \
		export DEPENDENCIES_OUTPUT; \
		$(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@ \
	)

#
# Link c++ objects
#
$(MXS_BUILDPREFIX)% : %$(MXS_CPP_EXTENSION) $(MXS_LINKOBJS) $(MXS_OBJDIR_DEP)
		$(CXX) $(CXXFLAGS) $(MXS_LINKOBJS) $(LDFLAGS) -o $@

#
# Build regular c++ into the build directory
#
$(MXS_BUILDPREFIX)%.o : %.c $(MXS_OBJDIR_DEP)
	( \
		$(RMF) $(@) $(@)$(MXS_DEPSUFFIX); \
		DEPENDENCIES_OUTPUT="$(@)$(MXS_DEPSUFFIX) $(@)"; \
		export DEPENDENCIES_OUTPUT; \
		$(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@ \
	)

#
# MSDEV build rule
#
#

.PHONY: msdev32_build
$(MXS_MSDEV32_RESULT) msdev32_build : $(MXS_OBJDIR_DEP)
	$(MXS_MSDEV32_BUILD_COMMAND)

define(M4X_APP_RULES,defn(`IN4_APP_RULES'))
M4X_APP_RULES()

ifneq ($(MXS_CXX_EXECUTABLE),)
$(MXS_CXX_EXECUTABLE) : $(MXS_LINKOBJS) $(MXS_OBJDIR_DEP)
	$(CXX) $(CXXFLAGS) $(MXS_LINKOBJS) $(LDFLAGS) -o $@

endif

ifneq ($(MXS_CXX_DSO),)
$(MXS_CXX_DSO_NAME) : $(MXS_LINKOBJS) $(MXS_OBJDIR_DEP)
	$(CXX) -shared $(CXXFLAGS) $(MXS_LINKOBJS) $(LDFLAGS) -o $@

endif

ifneq ($(MXS_C_EXECUTABLE),)
$(MXS_C_EXECUTABLE) : $(MXS_LINKOBJS) $(MXS_OBJDIR_DEP)
	$(CXX) $(CXXFLAGS) $(MXS_LINKOBJS) $(LDFLAGS) -o $@

endif

ifneq ($(MXS_C_DSO),)
$(MXS_C_DSO_NAME) : $(MXS_LINKOBJS) $(MXS_OBJDIR_DEP)
	$(CC) -shared $(CXXFLAGS) $(MXS_LINKOBJS) $(LDFLAGS) -o $@

endif

ifneq ($(MXS_STATIC_LIBRARY),)
$(MXS_STATIC_LIBRARY_NAME) : $(MXS_LINKOBJS) $(MXS_OBJDIR_DEP)
	$(AR) qcs $@ $(MXS_LINKOBJS)

endif

ifneq ($(MXS_STATIC_LIBRARY),)
$(MXS_STATIC_RELOCATABLE_NAME) : $(MXS_LINKOBJS) $(MXS_OBJDIR_DEP)
	$(LD) -r -o $@ $(MXS_LINKOBJS)

endif

define(`m4_make_rules',`
M4forech(Ix,m4_suffixes,`
$1%.Ix : %.Ix.m4 $(MXS_OBJDIR_DEP)
	rm -f $`'@ $2$`'@$(MXS_DEPSUFFIX)
	( \
		MXS_M4_RESULT="$`'@"; export MXS_M4_RESULT ; \
		MXS_M4_DEPEND="$2$`'@$(MXS_DEPSUFFIX)"; export MXS_M4_DEPEND ; \
		$(M4) $(MXS_`'upcase(Ix)M4FLAGS) -DMXS_M4_RESULT="$$MXS_M4_RESULT" -DMXS_M4_DEPEND="$$MXS_M4_DEPEND" -DMXI_ROOT="$(MXI_ROOT)" `$<' > $`'@ \
	)
')
')
m4_make_rules(`$(MXS_BUILDPREFIX)')
m4_make_rules(,`$(MXS_BUILDPREFIX)')


# Looking for header files
#
# This is to help editors that look for header files
#
# look for files in the MXS_IDIRS list of directories
#	prune out "//" to "/" using sed
#

ifeq ($(MXS_WHEREIS_ALL),1)
MXS_WHEREIS_TERMINATE=
else
MXS_WHEREIS_TERMINATE=exit 0;
endif

whereis/% :
	@for dir in $(MXS_IDIRS) $(MXS_GEN_STDINCLUDEDIRS); do \
		if [ -f $$dir/$(subst whereis/,,$(@)) ] ; then \
			echo $$dir/$(subst whereis/,,$(@)) | sed -e s%//%/%; \
			$(MXS_WHEREIS_TERMINATE) \
		fi; \
	done

#
# Print the build arch so that bundle scripts can find the
# files.
#
build_arch :
	@echo $(MXI_ARCH)

#
# Print the defintion of an environment variable
#
env/% :
	@echo '$($(notdir $@))'

#
# Print the build prefix so that bundle scripts can find the
# files.
#
build_prefix :
	@echo $(MXS_BUILDPREFIX)

#
# Print the build root so that bundle scripts can find the
# files.
#
build_root :
	@echo $(MXI_ROOT)

force_rebuild_vcproj/% :
	( \
		INL_VCPROJ_FORCE_BUILD=vcproj_force_build_phony; \
		export INL_VCPROJ_FORCE_BUILD; \
		$(MAKE) $(*).vcproj \
	)

#
# Create the work directory ifit's not already there 
#
ifneq ($(MXS_OBJDIR_DEP),)
$(MXS_OBJDIR_DEP) :
	@echo "creating $(MXS_OBJDIR_DEP)"
	-$(MKDIR) -p $(MXS_OBJDIR_DEP)
endif

ifneq ($(MXS_MAKEDIRS),)
M4X_IN_TARGS_SUBS_D
endif

#
# include all generated depend files
#
MXS_DEPLIST=$(wildcard $(MXS_BUILDPREFIX)*$(MXS_DEPSUFFIX))
ifneq ($(strip $(MXS_DEPLIST)),)
`include $(MXS_DEPLIST)'
endif
#

#
# Set the MOZ_TOOLS environment variable
export MOZ_TOOLS=$(MXS_MOZ_TOOLS)

changequote([,])
BC=`
FC='
changequote(`,')

